
image: xnyl/bat-builder:v1
# image: docker:18.09.7
# Use this if your GitLab runner does not use socket binding
services:
  - docker:18.09.7-dind

variables:
  DOCKER_HOST: tcp://docker:2375/
  DOCKER_DRIVER: overlay2
  DOCKER_TLS_CERTDIR: ""
  NODE_OPTIONS: --max_old_space_size=4096
  npm_config_cache: "$CI_PROJECT_DIR/.npm"
  CYPRESS_CACHE_FOLDER: "$CI_PROJECT_DIR/cache/Cypress"

# Cache modules in between jobs
cache:
  key: "$CI_COMMIT_REF_SLUG-$CI_COMMIT_TAG"
  paths:
    - node_modules/
    - .npm
    - cache/Cypress

stages:
  - test
  - build
  - deploy
  - e2e-test

.app-variables:
  variables: &app-variables
    REGISTRY_PACKAGE_IMAGE: ${CI_REGISTRY_IMAGE}/app
    PACKAGE_TAG: $CI_PIPELINE_ID

.app-dev-trigger:
  only: &app-dev-trigger
    refs:
      - develop
      - /^feature\/fp-.*$/
    changes:
      - "*"  # run pipeline if a root-level file like Makefile or docker-compose.yml is changed
      - "src/**/*"
      - "public/**/*"
      - "docker/**/*"
      - "k8s/**/*"

.app-stage-trigger:
  only: &app-stage-trigger
    refs:
      - master
      - /^release\/.*$/
      - merge_requests
      - tags

test-app:
  stage: test
  script:
    - yarn install --production # omit devDeps
    - yarn test

build-and-push-app:
  stage: build
  variables: *app-variables
  before_script:
    - bash ./scripts/docker-setup.sh
  script: # TODO: add multiple --tag $REGISTRY_PACKAGE_IMAGE:latest
    - echo "Building a Docker image... for ${REGISTRY_PACKAGE_IMAGE} $REGISTRY_PACKAGE_IMAGE"
    # fetches the latest image (not failing if image is not found)
    - docker pull $REGISTRY_PACKAGE_IMAGE:latest || true
    - yarn build
    - yarn ssr
    - echo "BUILD content created $(date) from pipeline id:$CI_PIPELINE_ID" > build/debug.html
    - >
      docker build
      --file docker/Dockerfile
      --pull
      --build-arg VCS_REF=$CI_COMMIT_SHA
      --build-arg VCS_URL=$CI_PROJECT_URL
      --cache-from $REGISTRY_PACKAGE_IMAGE:latest
      --tag $REGISTRY_PACKAGE_IMAGE:$PACKAGE_TAG
      .
    - docker push $REGISTRY_PACKAGE_IMAGE:$PACKAGE_TAG
  only: *app-dev-trigger

deploy-app-dev:
  stage: deploy
  cache: {}
  environment:
    name: development
  variables:
    <<: *app-variables
    KUBE_ENVIRONMENT: development
    KUBE_NAMESPACE: aeo-development
    KUBE_ENVIRONMENT_ADMIN_TOKEN: $KUBE_DEVELOPMENT_ADMIN_TOKEN
    KUBE_DEPLOYMENT_DOMAIN: aeo.xnyl.ovh
  script:
    - bash ./scripts/kubectl-setup-dynamic.sh
    - bash ./scripts/kubectl-deploy-dynamic.sh
  only: *app-dev-trigger

test-e2e-manual:
  image: cypress/base:10
  stage: e2e-test
  script:
    - yarn install
    - export CYPRESS_BASE_URL=${URL:-"http://aeo.xnyl.ovh"}
    - echo E2E testing for $CYPRESS_BASE_URL
    - yarn e2e:ci
  only: *app-dev-trigger
  when: manual

deploy-app-stage:
  stage: deploy
  cache: {}
  environment:
    name: staging
  variables:
    <<: *app-variables
    KUBE_ENVIRONMENT: staging
    KUBE_NAMESPACE: aeo-staging
    KUBE_ENVIRONMENT_ADMIN_TOKEN: $KUBE_STAGING_ADMIN_TOKEN
    KUBE_DEPLOYMENT_DOMAIN: stage.aeo.xnyl.ovh
  script:
    - bash ./scripts/kubectl-setup-dynamic.sh
    - bash ./scripts/kubectl-deploy-dynamic.sh
  only: *app-dev-trigger
  when: manual

test-e2e-stage:
  image: cypress/base:10
  stage: e2e-test
  variables:
    CYPRESS_BASE_URL: "http://stage.aeo.xnyl.ovh"
  script:
    - yarn install
    - yarn e2e:ci
  needs: ["deploy-app-stage"]


